<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
class DerivativeTypesController extends AppController {
	public $scaffold;
	public $uses = array('DerivativeType', 'Derivative');
	public $helpers = array('Menu', 'MyPaginator');
	public $paginate = array('limit' => 42, 'page' => 1, 'order'=>array('DerivativeType.name' => 'ASC'), 'recursive' => -1);
	
	public function index() {
		$this->paginate['limit'] = ($perColumn = Configure::read('Demyo.itemsPerIndexColumns')) * Configure::read('Demyo.columnsPerIndexPage');
		$this->set('perColumn', $perColumn);
		
		if (isset($this->params['named']['startsWith'])) {
			$this->paginate['page'] = $this->DerivativeType->findPageNumberStartsWith('name', $this->params['named']['startsWith'], $this->paginate['limit']);
		}
		
		$types =  $this->paginate('DerivativeType');
		$this->set('types', $types);
	}
	
	public function view($id = null) {
		if ($id === null)
			$this->redirect('/derivativeTypes');

		$this->DerivativeType->id = $id;
		$this->DerivativeType->recursive = -1;
		if (! $type = $this->DerivativeType->read())
			$this->errorNoSuchEntry(__('This derivative type does not exist.', true));
		$type = current($type);
		$type['derivative_count'] = $this->Derivative->getDerivativesCount('DerivativeType', $id);
		
		$this->set('type', $type);
	}
	
	public function add() {
		if (!empty($this->data)) {
			if ($this->DerivativeType->save($this->data)) {
				$this->smartFlash(__('The type has been added', true),
					'/derivativeTypes/view/'.$this->DerivativeType->id);
			}
		}
	}
	
	public function edit($id = null) {
		if (empty($this->data)) {
			$this->DerivativeType->id = $id;
			$this->DerivativeType->recursive = -1;
			$this->data = $this->DerivativeType->read();
			if (! $this->data = $this->DerivativeType->read())
				$this->errorNoSuchEntry(__('This derivative type does not exist.', true));
		}
		
		else {
			if ($this->DerivativeType->save($this->data)) {
				$this->smartFlash(__('The type has been updated', true),
					'/derivativeTypes/view/'.$this->data['DerivativeType']['id']);
			}
		}
	}
}

?>
