<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
class FeedsController extends AppController {
	public $uses = array('Collection', 'Publisher');
	public $components = array('SimplePie');
	public $helpers = array('SimplePieReader');
	
	public function from($model, $id) {
		$model = Inflector::camelize(Inflector::singularize($model));
		
		if (! isset($this->$model))
			return $this->feedError(__('Cannot get feeds for entries of this type', true));
		
		return $this->handleFeed($this->$model->getFeed($id));
	}
	
	public function demyoNews() {
		return $this->handleFeed('http://demyo.the4thlaw.org/rss');
	}
	
	private function handleFeed($feed) {
		if ($feed === false)
			return $this->feedError(__('No feed to show', true));
		
		$this->layout = 'ajax';
		$this->action = 'renderFeed';
		$this->set('isMultiFeed', is_array($feed));
		$this->set('feed', $feed === false?$feed:$this->SimplePie->getFeed($feed));
	}
	
	private function feedError($message) {
		$this->layout = 'ajax';
		$this->action = 'renderFeed';
		$this->set('feed', false);
		$this->set('error', $message);
	}
}

?>