<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
class PublishersController extends AppController {
	public $scaffold;
	public $uses = array('Publisher', 'Album');
	public $helpers = array('Feed', 'List', 'Menu', 'Quicksearch');
	
	public function index() {
		// It's easier to paginate the number of Collections from the
		// Collection model than from here. Else,the different pages would
		// have highly variable lengths
		$this->redirect('/collections');
	}
	
	public function view($id = null) {
		if ($id === null)
			$this->redirect('/publishers');

		$this->Publisher->id = $id;
		$this->Publisher->recursive = 1;
		$this->Publisher->unbindAll(array('hasMany' => array('Collection')), false);
		if (! $publisher = $this->Publisher->read())
			$this->errorNoSuchEntry(__('This publisher does not exist.', true));
		$publisher['Publisher']['album_count'] = $this->Album->getAlbumCount('Publisher', $id);
		
		$this->set('publisher', $publisher);
	}
	
	public function add() {
		if (!empty($this->data)) {
			if ($this->Publisher->save($this->data)) {
				$this->smartFlash(__('The publisher has been added', true),
					'/publishers/view/'.$this->Publisher->id);
			}
		}
		// else just show the form
	}
	
	public function edit($id = null) {
		if (empty($this->data)) {
			$this->Publisher->id = $id;
			if (! $this->data = $this->Publisher->read())
				$this->errorNoSuchEntry(__('This publisher does not exist.', true));
		}
		
		else {
			if ($this->Publisher->save($this->data)) {
				$this->smartFlash(__('The publisher has been updated', true),
					'/publishers/view/'.$this->data['Publisher']['id']);
			}
		}
	}
}

?>
