<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */

class SearchController extends AppController {
	public $uses = array('Series', 'Album', 'Author', 'Publisher', 'Collection', 'Tag', 'Source');
	
	public function quicksearch() {
		$this->layout = 'raw';
		
		if (empty($this->params['url']['q'])
				|| empty($this->params['named']['models']))
			return;
		
		$query = $this->params['url']['q'];
		$query = str_replace('*', '%', $query);
		$query = str_replace('?', '_', $query);
		if ($query[0] != '%')
			$query = '%'.$query;
		if ($query[strlen($query)-1] != '%')
			$query .= '%';
		
		$enabledModels = explode(',', $this->params['named']['models']);
		
		$results = array();
		
		// Not using a word index in another table might look ill-optimised but
		// the fields that are searched are so small it wouldn't give any
		// benefit besides looking more enterprisy
		$modelNames = array('Series', 'Album', 'Tag', 'Author', 'Publisher', 'Collection', 'Source');
		$conditions = array("name LIKE '$query'", "title LIKE '$query'",
			"name LIKE '$query'", 
			"name LIKE '$query' OR fname LIKE '$query' OR nickname LIKE '$query'", "name LIKE '$query'",
			"name LIKE '$query'", "name LIKE '$query'");
		$fields = array(array('id', 'name'), array('id', 'title'),
			array('id', 'name'), 
			array('id', 'name', 'fname', 'nickname'), array('id', 'name'),
			array('id', 'name'), array('id', 'name'));
		$orders = array('name ASC', 'title ASC', 'name ASC', 'name ASC', 'name ASC', 'name ASC', 'name ASC');
		$len = sizeof($modelNames);
		
		for ($i = 0; $i < $len; $i++)
			if (in_array($modelNames[$i], $enabledModels))
				$results[$modelNames[$i]] = Set::extract(
					$this->{$modelNames[$i]}->findAll($conditions[$i], $fields[$i], $orders[$i], null, 1, -1),
					'{n}.'.$modelNames[$i]);
		
		$this->set('results', $results);
	}
}
?>