<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
?>
<h2 id="requirements">Pré-requis</h2>
<p>Demyo a été testé sous Windows et Linux. Il fonctionne probablement aussi sous Mac OS X, mais cela n'a pas encore été testé.</p>
<p>Demyo est une application Web, ce qui signfie qu'il fonctionne dans un navigateur Web. A l'heure actuelle, les navigateurs suivants sont supportés :</p>
<ul>
<li>Moteur Gecko: Mozilla Firefox, Seamonkey, Iceweasel...</li>
</ul>
<p>Internet Explorer 7, Opera et Safari ne sont actuellement que partiellement supportés, et ces navigateurs pourraient présenter quelques problèmes mineurs. Un support complet est prévu pour une prochaine version.</p>
<p>Il n'y aura pas de support officiel pour Internet Explorer 6 ou plus ancien. La majeure partie du logiciel devrait fonctionner, mais quelques fonctions ne fonctionneront pas et aucun effort ne sera fait pour les adapter à ce navigateur en particulier.</p>

<p>Demyo requiert un serveur Web avec PHP 5.2 ou plus récent et MySQL 4 ou plus récent.
Si vous en avez déjà un, aller à <?=$helpBrowser->directLink('install-the-software')?>.
Si vous n'en avez pas ou si vous ne savez pas (auquel cas, vous n'en avez vraisemblablement pas), lisez ce qui suit.</p>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<h3 id="windows">Sous Windows</h3>
<p>Extrayez l'archive Demyo (.zip or .tar.gz) dans un répertoire temporaire de votre choix (sur le bureau ou dans le répertoire Mes Documents).</p>

<h4>XAMPP</h4>
<p>Téléchargez XAMPP-Lite depuis <a href="http://www.apachefriends.org/en/xampp.html">le site de XAMPP</a>.</p>
<p>Installez le logiciel à l'un des endroits suivants:</p>
<ol>
<li>A la racine d'un disque dur ou d'une clé USB, de sorte que le répertoire où seront les fichiers de XAMPP soit exactement <tt>X:\xampplite</tt> (où X est la lettre du disque dur ou de la clé USB). Dans ce cas, utilisez la version ZIP de XAMPP-Lite.</li>
<li>A n'importe quel autre endroit. Vous pouvez choisir la version ZIP ou l'installateur (.exe). Vous devrez <a href="http://www.apachefriends.org/en/xampp-windows.html#521">exécuter <tt>setup_xampp.bat</tt></a>).</li>
</ol>
<p class="note">Note: Si vous avez choisi la version complète d'XAMPP, le répertoire d'extraction devrait être nommé <tt>xampp</tt>. Ne le renommez pas, et suivez le manuel normalement, mais en remplaçant <tt>X:\xampplite</tt> par <tt>X:\xampp</tt></p>

<h4>Installation des fichiers</h4>
<p>Copiez <strong>le contenu</strong> du répertoire xampp-windows de Demyo dans le répertoire principal de XAMPP (par exemple <tt>X:\xampplite</tt>). Si vous avez une fenêtre demandant si vous voulez écraser les fichiers, répondez "Oui" pour tous.</p>
<p class="note">Sur Windows Vista, la copie des fichiers de cette façon ne fonctionne pas toujours correctement, probablement à cause d'un bug ou d'une fonctionnalité bizarre de Vista lui-même. Si Demyo se comporte de manière inattendue, vérifiez que les fichiers ont été correctement remplacés.</p>
<p>Démarrez XAMPP en exécutant <tt>X:\xampplite\xampp_start.exe</tt>. Une fenêtre DOS apparaît, réduisez-la.</p>
<p class="note">Note: La fenêtre DOS prévient quand XAMPP démarre, mais pas quand il est lancé. Une attente de 5 secondes devrait suffire.</p>

<h4>Sécurité</h4>
<p>Si vous avez copié correctement les fichiers trois étapes plus haut, votre installation devrait déjà être assez sécurisée. La page située à <a href="http://localhost/security/index.php">http://localhost/security/index.php</a> dit le contraire mais&nbsp;:</p>
<ul>
	<li>Les mots de passe n'ont pas vraiment d'importance si le serveur ne peut être atteint de l'extérieur (ce qui est le cas).</li>
	<li>Le safe mode de PHP est déprécié (c'est-à-dire que son usage est découragé par l'équipe PHP elle-même).</li>
</ul>

<h4>Fin de l'installation et utilisation</h4>
<p>L'installation est maintenant terminée. Chaque fois que vous voulez démarrer Demyo, démarrez le serveur web en exécutant <tt>X:\xampplite\xampp_start.exe</tt>. Pour l'arrêter, exécutez <tt>X:\xampplite\xampp_stop.exe</tt>.</p>
<p>En alternative, vous pouvez utiliser <tt>xampp-control.exe</tt>, qui possède une chouette interface graphique pour démarrer et Apache et MySQL, et se réduit dans la barre des tâches.</p>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<h3 id="linux">Sous Linux, avec les paquets logiciels de votre distribution</h3>
<p>Extraire l'archive Demyo (.zip or .tar.gz) dans un répertoire temporaire de votre choix. Dans ce qui suit, nous supposerons que le fichier a été extrait dans <tt>/tmp/demyo-VERSION</tt>.</p>

<h4>Debian</h4>
<p>Sous Debian (et probablement également sous Ubuntu), vous pouvez installer les paquets logiciels suivants: <tt>apache2 libapache2-mod-php5 mysql-server php5-mysql php5-gd</tt>&nbsp;. Pendant l'installation de la base de données SQL, vous pouvez être invité à donner un mot de passe pour le compte root. Tapez-le, et mémorisez-le. Si l'installation vous demande si le serveur MySQL devrait être joignable depuis le réseau, répondez non.</p>
<p>Vous pouvez aussi suivre les étapes ci-dessous:</p>
<ul>
	<li>Pour sécuriser votre installation en acceptant uniquement les requêtes en provenace de votre ordinateur, éditez le fichier <tt>/etc/apache2/ports.conf</tt> et remplacez <tt>Listen 80</tt> par <tt>Listen 127.0.0.1:80</tt>&nbsp;.</li>
	<li>Exécutez <tt>a2enmod rewrite</tt> en tant que root pour permettre à Apache 2 d'activer mod_rewrite, ce qui est nécessaire pour Demyo.</li>
	<li>Créez <tt>/etc/apache2/sites-available/demyo</tt> avec le contenu suivant :
	<pre>&lt;Directory /var/www/demyo&gt;
	AllowOverride FileInfo
&lt;/Directory&gt;</pre>
	et liez-le comme site disponible : <tt class="cmd">ln -s /etc/apache2/sites-available/demyo /etc/apache2/sites-enabled/demyo</tt></li>
	<li>Exécutez <tt class="cmd">invoke-rc.d apache2 restart</tt> pour recharger la configuration du serveur Web.</li>
</ul>
<p>Le serveur sera démarré automatiquement au démarrage de l'ordinateur.</p>

<h4>Autres distributions</h4>
<p>Veuillez vous référer à la documentation de votre système pour l'installation d'Apache sur d'autres distributions Linux.</p>

<!-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->

<h3 id="linux-lampp">Sous Linux avec, avec LAMPP</h3>
<p>Extrayez l'archive Demyo (.zip or .tar.gz) dans un répertoire temporaire de votre choix. Dans ce qui suit, nous supposerons que le fichier a été extrait dans <tt>/tmp/demyo-VERSION</tt>.</p>

<p>Si votre distribution ne dispose pas des paquets logiciels pour Apache ou s'ils ne fonctionnent pas en quelque façon (envisagez l'envoi d'un rapport de bug à votre distribution), vous pouvez également installer un serveur tout en un.</p>
<p class="note">Note: l'installation des paquets logiciels de votre distribution devrait être la meilleure solution. Il ne sera offert qu'un support limité voire aucun support du tout.</p>

<h4>XAMPP</h4>
<p>Téléchargez XAMPP pour Linux (LAMPP) depuis <a href="http://www.apachefriends.org/en/xampp.html">le site de XAMPP </a>.</p>
<p>Extrayez le fichier téléchargé dans <tt>/opt</tt>&nbsp;: dans un termainal, allez dans le répertoire où le fichier à été enregistré et exécutez <tt class="cmd">tar zxf xampp-linux-VERSION.tar.gz -C /opt</tt>&nbsp;. Il est nécessaire de disposer des privilèges root pour ce faire (utiliser <tt class="cmd">su</tt> ou <tt class="cmd">sudo</tt>).</p>
<p class="note">Note: Il n'est possible d'exécuter XAMPP pour Linux que depuis <tt>/opt</tt>&nbsp;, cependant vous l'installer ailleurs et réaliser un lien symbolique depuis <tt>/opt</tt> vers le répertoire de votre choix. Ceci restreint son usage depuis une clé USB à un ordinateur où vous avez un accès root (ou à quelqu'un qui peut réaliser ce lien symbolique).</p>

<h4>Securité</h4>
<p>Copiez les fichiers de configuration recommandés&nbsp;: dans un terminal, exécuter <tt class="cmd">cp -rf /tmp/demyo-VERSION/xampp-linux/* /opt/lampp/</tt>.</p>

<h4>Fin de l'installation et utilisation</h4>
<p>L'installation est maintenant terminée. Chaque fois que vous voulez démarrer Demyo, démarrez le serveur Web en exécutant <tt>/opt/lampp/demyo start</tt>. Pour l'arrêter, exécutez <tt>/opt/lampp/demyo stop</tt>.</p>
