<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
?>
<h2>Importer une collection ou une sauvegarde</h2>

<p>Demyo propose différentes manières d'importer un fichier listant une
collection existante.
Importer un tel fichier efface toute information contenue dans Demyo, et la
remplace par ce qui était renseigné dans le fichier.</p>

<p>À moins que cela ne soit explicitement précisé, importer un fichier ne
remplace que les informations textuelles. A fortiori, les images ne sont
pas modifiées (voir <?=$helpBrowser->directLink('manage-images')?>).</p>

<p>Inclure le support pour importer depuis un autre gestionnaire de collection
demande du travail. Si votre gestionnaire précédent n'est pas listé ici, vous
pouvez faire une demande (et attendre) ou trouver une manière de convertir
les données dans un des formats listés ci-dessous.</p>

<h3>Demyo: fichiers XML (+ XSL) et ZIP</h3>

<p>Demyo a son propre format basé sur XML. C'est le format de choix pour
toute récupération de données sans perte. Importer un fichier généré par une
ancienne version de Demyo n'est pas recommandé et peut impliquer une perte
de données. Dans de tels cas, Demyo demandera une confirmation avant
d'entreprendre des modifications irréversibles.</p>

<p>En plus des fichiers XML simples, Demyo permet aussi d'importer des archives
au format ZIP. Ces archives, créées par Demyo lors d'une exportation,
contiennent un fichier 'demyo.xml' avec les données textuelles et des
répertoires avec les images. Lors de l'import d'un fichier ZIP, les images
présentes sont supprimées et remplacées par celles du ZIP.</p>

<h3>Joker: CSV</h3>

<p>Les fichiers CSV sont les <em>Joker</em> pour l'import dans Demyo. Ils
peuvent être créés avec n'importe quel tableur (par exemple Microsoft Excel,
OpenOffice.org Calc) et permettent d'importer depuis plus de sources,
à condition de faire la conversion soi-même.</p>

<p>Le fichier doit respecter le format suivant&nbsp;:</p>
<ul>
	<li>Généralement créé avec un programme de tableur, le fichier doit être
	sauvé comme un <tt>.csv</tt>. Le programme demandera probablement de
	préciser quelques paramètres avant d'enregistrer le fichier&nbsp;:<ul>
		<li>Le séparateur de champ est le caractère : (deux points)</li>
		<li>Le protecteur de champ est le caractère " (guillemets droits)</li>
		<li>L'encodage est UTF-8 (ou Unicode si UTF-8 n'est pas disponible)</li>
	</ul></li>
	
	<li>La feuille de calcul doit mentionner un album par ligne, sans entête de
	colonne (celle-ci serait interprétée comme un album).</li>
	
	<li>La feuille de calcul doit comporter les colonnes suivantes, dans
	l'ordre exact. Si une colonne n'a pas de contenu (par exemple parce que
	le système précédent ne conservait pas de valeur pour ce champ), la
	colonne devrait rester vide.<ul>
		<li>Nom de la série</li>
		<li>Cycle pour l'album</li>
		<li>Numéro de l'album</li>
		<li>Titre de l'album</li>
		<li>Nom et prénom du dessinateur</li>
		<li>Nom et prénom du scénariste</li>
		<li>Nom et prénon du coloriste</li>
		<li>Éditeur</li>
		<li>Collection</li>
		<li>Date de première édition (au format AAAA-MM-JJ)</li>
		<li>Date de l'édition de l'album (au format AAAA-MM-JJ)</li>
		<li>Date d'achat (au format AAAA-MM-JJ)</li>
		<li>ISBN</li>
		<li>Reliure</li>
		<li>Nombre de pages</li>
		<li>Résumé</li>
		<li>Commentaire</li>
		<li>Prix</li>
	</ul></li>
</ul> 