<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
$this->pageTitle = __('Borrowers', true);

$borrowerUrlPart = $fromBorrower?"borrower:$fromBorrower":'';
if ($showingAll)
	$menu->makePopupMenu(array(array('url' => '/borrowers/index/onlyCurrent:true'.$borrowerUrlPart, 'title' => __('See current loans only', true))));
else
	$menu->makePopupMenu(array(array('url' => '/borrowers/index/onlyCurrent:false'.$borrowerUrlPart, 'title' => __('Include past loans', true))));

if (empty($loans)) {
	echo '<div class="info">',__('No loans to show', true),'</div>';
	return;
}
?>
<h2><?php
if ($showingAll)
	__('Loan history (including returned albums):');
else
	__('Albums currently lended:');
?></h2>

<form action="<?=Router::url('/borrowers/getBack')?>" method="post">
<ul id="loan_list">

<?php
foreach($loans as &$loan) {
	$number = (empty($loan['Album']['cycle'])?'':($loan['Album']['cycle'].'.')).$loan['Album']['number'];
	$title = "<a href=\"".Router::url('/series/view/'.$loan['Album']['Series']['id'])."\">{$loan['Album']['Series']['name']}</a> - $number - <a href=\"".Router::url('/albums/view/'.$loan['Album']['id'])."\">{$loan['Album']['title']}</a>";
	
	$hide = '';
	$returnDate = __date($loan['AlbumsBorrower']['return_date']);
	if (empty($returnDate))
		$text = __s('%s: lended to %s since %s',
			$title,
			'<a href="'.Router::url('/borrowers/view/'.$loan['Borrower']['id']).'">'.$loan['Borrower']['meta_name'].'</a>',
			__date($loan['AlbumsBorrower']['borrow_date']));
	else {
		$text = __s('%s: lended to %s from %s to %s',
			$title,
			'<a href="'.Router::url('/borrowers/view/'.$loan['Borrower']['id']).'">'.$loan['Borrower']['meta_name'].'</a>',
			__date($loan['AlbumsBorrower']['borrow_date']),
			$returnDate);
		$hide = 'style="visibility: hidden" disabled="disabled"';
	}
	?>
	<li><input type="checkbox" name="data[Album][<?=$loan['Album']['id']?>]" id="album<?=$loan['Album']['id']?>" <?=$hide?> /><label for="album<?=$loan['Album']['id']?>"><?=$text?></label></li>
	<?php
}
?>

</ul>
<input type="submit" id="loan-get-back" value="<?php __('Mark selected albums as returned'); ?>" />
</form>

<?php if ($doPaginate) { ?>
<div class="pages_nav_numbers">
	<?=$myPaginator->prev()?> <?=$myPaginator->numbers()?> <?=$myPaginator->next()?>
</div>
<div class="pages_nav_jump">
	<?=$myPaginator->directJump()?>
</div>
<?php } ?>