<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
$isEdit = isset($isEdit) && $isEdit;

$quicksearch->setSearchCategories(array('Series', 'Album'));

$menu->makePopupMenu(array(
	array('add' => 'Series'),
	array('add' => 'Album'),
	array('add' => 'Author'),
	array('add' => 'DerivativeType'),
	array('add' => 'Image')
));
?>

<form class="addedit" method="post" action="<?=Router::url('/derivatives/'.($isEdit?'edit':'add'))?>">
<fieldset>
<legend><?=($isEdit?__('Edit a derivative', true):__('Add a derivative', true))?></legend>
<?php
if ($isEdit)
	echo $form->hidden('Derivative.id');
?>
<input type="hidden" name="smartFlash" value="<?=$smartFlash?>" />
<table class="details">
<?php
$jQuery->checkInclude();

echo '<tr><th>'.$form->label('Derivative.series_id', __('Series', true)).'</th><td>'.$form->select('Derivative.series_id', $seriesList, null, array(), null)."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.album_id', __('Album', true)).'</th><td>'.$form->select('Derivative.album_id', $albumsList, null, array(), __('[ none ]', true))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.artist_id', __('Artist', true)).'</th><td>'.$form->select('Derivative.artist_id', $authorsList, null, array(), null)."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.derivative_type_id', __('Type', true)).'</th><td>'.$form->select('Derivative.derivative_type_id', $typesList, null, array(), null)."</td></tr>\n";
echo '<tr><th>'.$form->label('Source.name', __('Source', true)).'</th><td>'.$form->text('Source.name')."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.number', __('Exemplar number', true)).'</th><td>'.$form->text('Derivative.number', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.total', __('Total exemplars', true)).'</th><td>'.$form->text('Derivative.total', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.colors', __('Colors', true)).'</th><td>'.$form->text('Derivative.colors', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.signed', __('Signed', true)).'</th><td>'.$form->checkbox('Derivative.signed')."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.authors_copy', __('Author\'s copy', true)).'</th><td>'.$form->checkbox('Derivative.authors_copy')."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.restricted_sale', __('Restricted sale', true)).'</th><td>'.$form->checkbox('Derivative.restricted_sale')."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.width', __('Width', true)).'</th><td>'.$form->text('Derivative.width', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.height', __('Height', true)).'</th><td>'.$form->text('Derivative.height', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.depth', __('Depth', true)).'</th><td>'.$form->text('Derivative.depth', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.purchase_date', __('Purchase date', true)).'</th><td>'.$form->text('Derivative.purchase_date', array('class' => 'date'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.price', __('Price', true)).'</th><td>'.$form->text('Derivative.price', array('class' => 'number'))."</td></tr>\n";
echo '<tr><th>'.$form->label('Image.Image', __('Images', true)).'</th><td>'.$form->select('Image.Image', $imagesList, null, array('multiple' => 'multiple', 'size' => Configure::read('Demyo.View_multiSelectHeight')), null)."</td></tr>\n";
echo '<tr><th>'.$form->label('Derivative.description', __('Description', true)).'</th><td>'.$form->textarea('Derivative.description', Configure::read('Demyo.View_textareaAttribs'))."</td></tr>\n";
?>
</table>
<script type="text/javascript">
//<![CDATA[
jQuery('input.number').numberField({ default: 1 });
jQuery('input.date').date_input();

jQuery('input#SourceName').autocomplete('<?=Router::url('/sources/complete', true)?>', {
	selectFirst: false
});

var initialSeriesID = <?=empty($this->data['Derivative']['series_id'])?0:$this->data['Derivative']['series_id']?>;
var initialAlbumID = <?=empty($this->data['Derivative']['album_id'])?0:$this->data['Derivative']['album_id']?>;

function updateAlbumList() {
	var id = jQuery('select#DerivativeSeriesId').val();
	jQuery.get('<?=Router::url('/albums/fromSeries/')?>'+id, function(data) {
		jQuery('select#DerivativeAlbumId').html('<option value=""><?php __('[ none ]') ?><\/option>' + data);
		
		// Reset to initial album if series goes back to initial value
		if (id == initialSeriesID)
			jQuery('select#DerivativeAlbumId').val(initialAlbumID);
	});
}

jQuery(function() {
	jQuery('select#DerivativeSeriesId').bind('change', updateAlbumList);
	jQuery('input[type="reset"]').bind('click', function() {
		// On reset, reload the correct album list (which, incidentally, sets the correct album ID *after* AJAX reload)
		jQuery('select#DerivativeSeriesId').val(initialSeriesID);
		jQuery('select#DerivativeSeriesId').trigger('change');
	});
	updateAlbumList();
});
//]]>
</script>
<div class="buttons"><input type="submit" value="<?php if ($isEdit) __('Update'); else __('Add')?>" /><input type="reset" value="<?php __('Reset')?>" /></div>
</fieldset>
</form>