<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
class JQueryHelper extends AppHelper {
	public $helpers = array('Javascript');

	private $hasIncludedScript = false;

	public function checkInclude() {
		if ($this->hasIncludedScript)
			return;
		
		$this->Javascript->link('jquery', false);
		$this->Javascript->link('jquery.ui', false);
		$this->Javascript->link('jquery.color', false);
		$this->Javascript->link('jquery.slider', false);
		$this->Javascript->link('jquery.delayedevent', false);
		$this->Javascript->link('jquery.dimensions', false);
		$this->Javascript->link('jquery.date_input', false); // http://jonathanleighton.com/projects/date-input
		$this->Javascript->link('jquery.numberfield', false);
		$this->Javascript->link('jquery.autocomplete', false);
		// Was optional for autocomplete in case server didn't answer before next input character
		//$this->Javascript->link('jquery.ajaxQueue', false);
		$this->Javascript->link('jquery.hotkeys', false);
		$this->hasIncludedScript = true;
	}

	/** Outputs a flashing warning */
	public function warning($text, $echo = true) {
		$this->checkInclude();

		$warn = <<<EOS
<div class="warning">$text</div>
<script type="text/javascript">
var \$jq = jQuery.noConflict();
\$jq(document).ready(function() {
	jQuery('div.warning').css('background-color', '#f55');
	jQuery('div.warning').animate({backgroundColor: '#feb'}, 2000);
});
</script>

EOS;
		if ($echo)
			echo $warn;
		else
			return $warn;
	}
}
?>
