<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */

class QuicksearchHelper extends AppHelper {
	public $helpers = array('jQuery');
	public $enabledCategories = array();
	private $availableCategories = array('Series', 'Album', 'Tag', 'Author', 'Publisher', 'Collection', 'Source');

	public function setSearchCategories($categories) {
		if (! is_array($categories))
			$categories = array($categories);
		
		if (! empty($categories))
			$this->jQuery->checkInclude();
		
		$this->enabledCategories = $categories;
	}
	
	public function enableAllCategories() {
		$this->enabledCategories = $this->availableCategories;
	}
	
	public function getSearchCategories() {
		return $this->enabledCategories;
	}
	
	public function showQuickSearch($echo = true) {
		if (empty($this->enabledCategories))
			return '';
		
		if (Configure::read('Demyo.Quicksearch_newWindow'))
			$qsAction = 'window.open(item[2]);';
		else
			$qsAction = 'location.href = item[2];';
		
		$shortcut = Configure::read('Demyo.Quicksearch_shortcut');
		
		$url = Router::url(array('controller' => 'search', 'action' => 'quicksearch', 'models' => implode(',', $this->enabledCategories), false));
		$searchTitle = __('Quick search:', true);
		$fieldTitle = __s('Quick search (%s)', $shortcut);
		$form = <<<EOS
<script type="text/javascript">
//<![CDATA[

jQuery.noConflict();
jQuery(document).ready(function() {
	jQuery('div#quicksearch input[name="quicksearch-query"]').autocomplete('$url', {
		formatItem: function(item) {
			var fmt = item[0];
			if (item[1].length > 0)
				fmt += ' <em>('+item[1]+')<\/em>';
			return fmt;
		},
		minChars: 2,
		max: 25,
		matchContains: true
	}).result(function(event, item) {
		// Go to given URL
		$qsAction
	});
	
	jQuery(document).bind('keydown', '$shortcut', function() {jQuery('div#quicksearch input[name="quicksearch-query"]').focus()});
});
//]]>
</script>

<div id="quicksearch">
	<form action="" onsubmit="return false;" method="post"><div>
		<h1>$searchTitle</h1>
		<input type="text" name="quicksearch-query" value="" title="$fieldTitle" />
	</div></form>
</div>
EOS;
	
		if ($echo)
			echo $form;
		else
			return $form;
	} 
}

?>
