<?php
/* Copyright 2007-2009 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
$this->pageTitle = $source['name'].' - '.__('Sources', true);

$quicksearch->setSearchCategories(array('Source'));

$menu->makePopupMenu(array(
	array('edit' => 'Source', 'id' => $source['id']),
	array('delete' => 'Source', 'id' => $source['id'])
));
?>
<table class="details">
	<tr><th><?php __('Name') ?></th><td><?=$source['name']?></td></tr>
	
	<?php if (!empty($source['website'])): ?>
	<tr><th><?php __('Website') ?></th><td><a href="<?=$source['website']?>"><?=$source['website']?></a></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['email'])): ?>
	<tr><th><?php __('Mail') ?></th><td><a href="mailto:<?=$source['email']?>"><?=$source['email']?></a></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['owner'])): ?>
	<tr><th><?php __('Owner') ?></th><td><?=$source['owner']?></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['address'])): ?>
	<tr><th><?php __('Address') ?></th><td><?=nl2br($source['address'])?></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['phone_number'])): ?>
	<tr><th><?php __('Phone number') ?></th><td><?=$source['phone_number']?></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['history'])): ?>
	<tr><th><?php __('History') ?></th><td><?=nl2br($source['history'])?></td></tr>
	<?php endif; ?>
	
	<?php if (!empty($source['derivative_count'])): ?>
	<tr><th><?php __('Derivatives') ?></th>
	<td><?=$html->link(__s('View %d derivatives from this source', $source['derivative_count']), '/derivatives/index/fromSource:'.$source['id'])?>
	<a id="derivatives-inliner" href="#inline-derivatives">(<?php __('view them here')?>)</a></td></tr>
	<?php endif; ?>
</table>

<div id="inline-derivatives" style="display: none"><div class="loading"><?=__('Loading')?></div></div>

<script type="text/javascript">
jQuery('a#derivatives-inliner').one('click', showInlineDerivatives);
function showInlineDerivatives() {
	jQuery('div#inline-derivatives').show();
	jQuery.get('<?=Router::url(array('controller' => 'derivatives', 'action' => 'index', 'fromSource' => $source['id']))?>', {}, function(data) {
		jQuery('div#inline-derivatives').html(data);
		<?php echo $shadowbox->init(false);?>
	});
}
</script>
