/* Copyright 2007, 2008 Xavier 'Xr' Dalem
 * 
 * This file is part of Demyo. Demyo is free software: you can redistribute it
 * and/or modify it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 * 
 * Demyo is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU GPLv3 for more details.
 */
/*
jQuery.slider

Inspired by jQuery.imageMenu
<http://ldbglobe.fried-rice.net/public/2007/06/jQuery.imageMenu/>,
which itself took its inspiration from phatfusion image Menu
<http://www.phatfusion.net/imagemenu/index.htm>

There's hardly anything left from jQuery.imageMenu, and I doubt that there's a
patent on phatfusion's so I can probably relicence it.

usage: $('ul#foo').slider(settings)
settings is a hash map with the following keys:
	easing			The easing to use for animations
	speed			The animation speed
	delay			The delay for hover activation (i.e. how long you have to
					hover an element to switch to it).
	defaultWidth	The default width for list elements whose image size cannot
					be computed (e.g. because it is empty or contains only text)
*/
// TODO: rename to imageSlider
(function() {
jQuery.fn.extend({
	slider: function(settings) {
		if (! this.length)
			return this;
			
		// setup configuration
		settings = jQuery.extend({
			easing: 'swing',
			speed: 'fast',
			delay: 300,
			defaultWidth: 45
		}, settings);
		
		var listTotalWidth, optimalWidth;
		// Ratio of slider to container
		var originalWidthRatio = jQuery(this).width() / jQuery(jQuery(this).parent().get(0)).width();
		var children = jQuery('li', this);
		
		// Cache maximum widths of all children
		var maxWidths = new Array(children.length);
		var maxTotalWidth = 0;
		children.each(
			function(i) {
				maxWidths[i] = jQuery('img', this).width();
				if (maxWidths[i] == null)
					maxWidths[i] = settings.defaultWidth;
				maxTotalWidth += maxWidths[i];
			}
		);
		
		// The following allows us to clip the overflowing elements rather
		// than overflow them. Saves some computation since the actual width
		// of an element takes the borders into account
		this.css('position','relative');
		this.append('<div style="position:absolute;height:'
			+this.height()+'px;" class="containerJKjFJN"></div>'); // name should avoid conflicts with user-specified CSS
		children.appendTo(jQuery('.containerJKjFJN',this));
		// TODO: use a really random id rather than this
		
		if (! this.is('ul')) // only ul's are supported
			return this;
		
		this.css('list-style','none');
		this.css('overflow','hidden');
		children.css('float','left');
		
		function mouseOver(a, target) {
			// Handle both normal hover and delayed event
			if (typeof(target) == 'undefined')
				target = this;
			target = jQuery(target);
			
			// Stop animation of all elements
			children.stop();
			
			// Compute the widths each time. This allows for elements of
			// different sizes to scale according to their own size, not
			// to the largest size (very useful for elements of varying widths)
			var baseWidths = new Array(children.length);
			children.each(function(i, val) {
				baseWidths[i] = jQuery(this).width();
			});
			var widthOfHovered = target.width();
			
			var maxWidthOfHovered = maxWidths[children.index(target)];
			var remainingWidthForOthers = listTotalWidth-maxWidthOfHovered;
			// Ceil rather than floor to avoid a gap at the end, even if that
			// means killing a few pixels of the last child
			hoverMinWidth = Math.ceil(remainingWidthForOthers/(children.length-1));
			
			// Skip animation if the width is already OK
			if (maxWidthOfHovered <= target.width())
				return;
			
			// Animate the stuff by ourselves: allows for a more seamless
			// animation.
			children.not(target).animate({'width': hoverMinWidth}, {
				step: function(now) {
					// Each time we reduce the size of a child, we increase
					// the size of the target by the same size.
					var index = children.index(this);
					var width = Math.floor(now);
					widthOfHovered += baseWidths[index]-width;
					baseWidths[index] = width;
					if (widthOfHovered > maxWidthOfHovered)
						widthOfHovered = maxWidthOfHovered
					target.width(widthOfHovered);
				},
				
				complete: function() {
					// Since we round everything (there's no such thing as
					// half a pixel and I felt the script was snappier),
					// the target might end not as large as we would have wanted
					target.width(maxWidthOfHovered);
				}
			});
		}
		
		function mouseOut() {
			children.stop();
			children.animate({'width':optimalWidth}, settings.speed, settings.easing);
		}
		
		function noop() {}
		
		function resetBehaviour(self) {
			var jqSelf = jQuery(self);
			
			// Remove any existing hover events
			children.unbind('mouseover');
			jqSelf.unbind('mouseout');
			
			// Reset original width ratio since we maybe changed it before resize occured
			jqSelf.width(originalWidthRatio*jQuery(jqSelf.parent().get(0)).width());
			
			listTotalWidth = jqSelf.width();
			optimalWidth = Math.floor(listTotalWidth / children.length);
			
			// Adjust so that we don't have a gap at the end, even if that means
			// we delete a part of the last cover
			if ((listTotalWidth - (optimalWidth * children.length)) > 0)
				optimalWidth++;
			
			// If the list is too large, crop it to avoid blank space and
			// don't animate
			if (maxTotalWidth < listTotalWidth) {
				jqSelf.width(maxTotalWidth);
				// Set children to their max width since we have room.
				// This is useless the first time since they already have their
				// max width but is necessary when reducing then restoring
				// window size.
				children.each(
					function(i) {
						jQuery(this).width(maxWidths[i]);
					}
				);
				return;
			}
			
			// Add event handlers
			// Don't want the dependency on delayedEvent ? Switch the comments
			children.delayedEvent('mouseover', mouseOver, {timeout: settings.delay});
			jqSelf.delayedEvent('mouseout', mouseOut, {timeout: settings.delay});
			//children.hover(mouseOver, noop);
			//this.hover(noop, mouseOut);
			
			// Set initial width
			children.width(optimalWidth);
			
			jQuery('.containerJKjFJN').width(listTotalWidth*2);
		}
		
		resetBehaviour(this);
		
		var self = this;
		jQuery(window).resize(function() { resetBehaviour(self); });
		return this;
	}
});

})();

